Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/MisleadingClickCueRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/MisleadingClickCueRule.java	(revision 1918)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/MisleadingClickCueRule.java	(revision 1918)
@@ -0,0 +1,241 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.usability;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import de.ugoe.cs.autoquest.eventcore.IEventType;
+import de.ugoe.cs.autoquest.eventcore.gui.MouseButtonInteraction;
+import de.ugoe.cs.autoquest.eventcore.gui.MouseClick;
+import de.ugoe.cs.autoquest.eventcore.gui.MouseDoubleClick;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IGUIElement;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IGUIView;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IImage;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IText;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.DefaultTaskInstanceTraversingVisitor;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IUserSession;
+
+/**
+ * TODO comment
+ * 
+ * @version $Revision: $ $Date: 16.07.2012$
+ * @author 2012, last modified by $Author: pharms$
+ */
+public class MisleadingClickCueRule implements UsabilityEvaluationRule {
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.usability.UsabilityEvaluationRule#evaluate(TaskTree)
+     */
+    @Override
+    public UsabilityEvaluationResult evaluate(ITaskModel taskModel) {
+        UselessClickStatistics statistics = new UselessClickStatistics();
+        int allObserved = calculateStatistics(taskModel.getUserSessions(), statistics);
+
+        UsabilityEvaluationResult results = new UsabilityEvaluationResult(taskModel);
+        analyzeStatistics(statistics, allObserved, results);
+
+        return results;
+    }
+
+    /**
+     *
+     */
+    private void analyzeStatistics(UselessClickStatistics    statistics,
+                                   int                       allObserved,
+                                   UsabilityEvaluationResult results)
+    {
+        for (Map.Entry<IGUIView, Map<IGUIElement, Integer>> uselessClickCounter :
+                statistics.getUselessClickCounters().entrySet())
+        {
+            for (Map.Entry<IGUIElement, Integer> counter : uselessClickCounter.getValue().entrySet())
+            {
+                int uselessClicks = counter.getValue();
+                int noOfViewDisplays = statistics.getViewOpenedCount(uselessClickCounter.getKey());
+
+                int ratio = Math.min(1000, 1000 * uselessClicks / noOfViewDisplays);
+
+                UsabilitySmellIntensity intensity =
+                    UsabilitySmellIntensity.getIntensity(ratio, uselessClicks, -1);
+
+                if (intensity != null) {
+                    Map<String, Object> parameters = new HashMap<String, Object>();
+                    parameters.put("noOfViewDisplays", noOfViewDisplays);
+                    parameters.put("uselessClicks", uselessClicks);
+                    parameters.put("element", counter.getKey());
+                    parameters.put("view", uselessClickCounter.getKey());
+
+                    results.addSmell
+                        (intensity, UsabilitySmellDescription.MISLEADING_CLICK_CUE, parameters);
+                }
+            }
+        }
+    }
+
+
+    /**
+     * 
+     */
+    private int calculateStatistics(List<IUserSession>            sessions,
+                                     final UselessClickStatistics statistics)
+    {
+        final List<IEventTaskInstance> leafNodes = new ArrayList<>();
+        final IGUIView[] currentView = new IGUIView[1];
+        
+        for (IUserSession session : sessions) {
+            currentView[0] = null;
+            
+            for (final ITaskInstance currentRoot : session) {
+                currentRoot.accept(new DefaultTaskInstanceTraversingVisitor() {
+                    @Override
+                    public void visit(IEventTaskInstance eventTaskInstance) {
+                        leafNodes.add(eventTaskInstance);
+                        
+                        if (eventTaskInstance.getEvent().getTarget() instanceof IGUIElement) {
+                            IGUIView view =
+                                ((IGUIElement) eventTaskInstance.getEvent().getTarget()).getView();
+                            
+                            if (((currentView[0] == null) && (view != null)) ||
+                                ((currentView[0] != null) && (!currentView[0].equals(view))))
+                            {
+                                currentView[0] = view;
+                                statistics.addViewOpened(view);
+                            }
+                            
+                            if (isUselessMouseClick(eventTaskInstance)) {
+                                statistics.addUselessClick(eventTaskInstance);
+                            }
+                        }
+                    }
+                });
+            }
+        }
+        
+        return leafNodes.size();
+    }
+
+    /**
+     *
+     */
+    private boolean isUselessMouseClick(IEventTaskInstance eventTaskInstance) {
+        IEventType type = eventTaskInstance.getEvent().getType();
+        
+        if ((!(type instanceof MouseClick)) && (!(type instanceof MouseDoubleClick))) {
+            return false;
+        }
+        
+        if (((MouseButtonInteraction) type).getButton() != MouseButtonInteraction.Button.LEFT) {
+            return false;
+        }
+                
+        IGUIElement target = (IGUIElement) eventTaskInstance.getEvent().getTarget();
+        
+        if ((target instanceof IImage) /*|| (target instanceof IPanel) ||
+            (target instanceof IProgressBar) || (target instanceof IScrollPane) ||
+            (target instanceof IShape) || (target instanceof ITable)*/ ||
+            (target instanceof IText))
+        {
+            return true;
+        }
+        else {
+            return false;
+        }
+    }
+
+    /**
+     *
+     */
+    private class UselessClickStatistics {
+        
+        /** */
+        private Map<IGUIView, Integer> viewOpenedCounters = new HashMap<>();
+        
+        /** */
+        private Map<IGUIView, Map<IGUIElement, Integer>> uselessClickCounters = new HashMap<>();
+
+        /**
+         * <p>
+         * TODO: comment
+         * </p>
+         *
+         * @param view
+         */
+        private void addViewOpened(IGUIView view) {
+            Integer counter = viewOpenedCounters.get(view);
+            
+            if (counter == null) {
+                viewOpenedCounters.put(view, 1);
+            }
+            else {
+                viewOpenedCounters.put(view, counter + 1);
+            }
+        }
+
+        /**
+         * <p>
+         * TODO: comment
+         * </p>
+         *
+         * @param eventTaskInstance
+         */
+        private void addUselessClick(IEventTaskInstance eventTaskInstance) {
+            Map<IGUIElement, Integer> counterMap = uselessClickCounters.get
+                (((IGUIElement) eventTaskInstance.getEvent().getTarget()).getView());
+            
+            if (counterMap == null) {
+                counterMap = new HashMap<>();
+                uselessClickCounters.put
+                    (((IGUIElement) eventTaskInstance.getEvent().getTarget()).getView(), counterMap);
+            }
+            
+            Integer counter = counterMap.get(eventTaskInstance.getEvent().getTarget());
+            
+            if (counter == null) {
+                counterMap.put((IGUIElement) eventTaskInstance.getEvent().getTarget(), 1);
+            }
+            else {
+                counterMap.put((IGUIElement) eventTaskInstance.getEvent().getTarget(), counter + 1);
+            }
+        }
+
+        /**
+         *
+         */
+        private Map<IGUIView, Map<IGUIElement, Integer>> getUselessClickCounters() {
+            return uselessClickCounters;
+        }
+
+        /**
+         *
+         */
+        private int getViewOpenedCount(IGUIView view) {
+            Integer counter = viewOpenedCounters.get(view);
+            
+            if (counter == null) {
+                return 0;
+            }
+            else {
+                return counter;
+            }
+        }
+    }
+}
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/MissingFeedbackRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/MissingFeedbackRule.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/MissingFeedbackRule.java	(revision 1918)
@@ -78,8 +78,8 @@
             // be considered as usability smell.
             
-            UsabilityDefectSeverity severity = UsabilityDefectSeverity.getSeverity
-                (entry.getValue(), 2000, 1000, 500, 50, entry.getKey(), taskModel);
-
-            if (severity != null) {
+            UsabilitySmellIntensity intensity =
+                UsabilitySmellIntensity.getIntensity(entry.getValue(), entry.getKey(), taskModel);
+
+            if (intensity != null) {
                 Map<String, Object> parameters = new HashMap<String, Object>();
 
@@ -88,6 +88,4 @@
                 long cummulatedWaitingTime = 0;
                 int numberOfAdditionalClicks = 0;
-                
-                System.out.println("\n\n#################################");
                 
                 Event exampleEvent = null;
@@ -101,5 +99,4 @@
                         for (List<Event> subsequence : clicksOnIdenticalButton) {
                             exampleEvent = subsequence.get(0);
-                            System.out.println(exampleEvent.getTimestamp());
                             
                             Event endEvent = subsequence.get(subsequence.size() - 1);
@@ -123,6 +120,6 @@
                 parameters.put("task", entry.getKey());
                 
-                results.addDefect
-                    (severity, UsabilityDefectDescription.MISSING_FEEDBACK, parameters);
+                results.addSmell(entry.getKey(), intensity,
+                                 UsabilitySmellDescription.MISSING_FEEDBACK, parameters);
             }
         }
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/RequiredInefficientActionsRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/RequiredInefficientActionsRule.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/RequiredInefficientActionsRule.java	(revision 1918)
@@ -67,6 +67,6 @@
             int ratio = (int) (1000 * stats.getMean());
 
-            UsabilityDefectSeverity severity = UsabilityDefectSeverity.getSeverity
-                (ratio, 500, 300, 200, 100, entry.getKey(), taskModel);
+            UsabilitySmellIntensity severity =
+                UsabilitySmellIntensity.getIntensity(ratio, entry.getKey(), taskModel);
 
             if (severity != null) {
@@ -75,6 +75,6 @@
                 parameters.put("ratio", (ratio / 10));
 
-                results.addDefect
-                    (severity, UsabilityDefectDescription.INEFFICIENT_ACTIONS, parameters);
+                results.addSmell(entry.getKey(), severity,
+                                 UsabilitySmellDescription.INEFFICIENT_ACTIONS, parameters);
             }
         }
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/RuleUtils.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/RuleUtils.java	(revision 1918)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/RuleUtils.java	(revision 1918)
@@ -0,0 +1,265 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.usability;
+
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.ListIterator;
+import java.util.Map;
+
+import de.ugoe.cs.autoquest.eventcore.guimodel.GUIElementGroup;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IGUIElement;
+
+/**
+ * <p>
+ * TODO comment
+ * </p>
+ * 
+ * @author Patrick Harms
+ */
+class RuleUtils {
+
+    /**
+     *
+     */
+    static Map<IGUIElement, List<IGUIElement>> getGroups(Collection<IGUIElement> guiElements,
+                                                         int                     maxDistToCommonParent)
+    {
+        Map<IGUIElement, List<IGUIElement>> groups = new HashMap<>();
+        List<IGUIElement> guiElementsToGroup = new LinkedList<>(guiElements);
+        IGUIElement parentToGroup;
+        
+        do {
+            List<LinkedList<IGUIElement>> sortedPaths = new LinkedList<>();
+            List<IGUIElement> commonParents = new LinkedList<>();
+            
+            createSortedPaths
+                (guiElementsToGroup, sortedPaths, commonParents, maxDistToCommonParent);
+
+            // >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> TEST IMPLEMENTATION
+            // Iterator<LinkedList<IGUIElement>> sortedPathsIt1 = sortedPaths.iterator();
+            // Iterator<IGUIElement> commonParentIt1 = commonParents.iterator();
+            //  
+            // while (commonParentIt1.hasNext()) {
+            //     IGUIElement currentParent = commonParentIt1.next();
+            //     IGUIElement sortedPath = sortedPathsIt1.next().getLast();
+            //     
+            //     System.out.println(toPathString(sortedPath));
+            //     System.out.println(toPathString(currentParent) + "###########");
+            // }
+            //  
+            // System.out.println();
+            // <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< TEST IMPLEMENTATION
+            
+            parentToGroup = getParentToGroup(commonParents);
+        
+            if (parentToGroup != null) {
+                Iterator<LinkedList<IGUIElement>> sortedPathsIt = sortedPaths.iterator();
+                ListIterator<IGUIElement> commonParentIt = commonParents.listIterator();
+        
+                while (commonParentIt.hasNext()) {
+                    if (!parentToGroup.equals(commonParentIt.next())) {
+                        sortedPathsIt.next();
+                    }
+                    else {
+                        break;
+                    }
+                }
+                
+                List<IGUIElement> groupedGUIElements = new LinkedList<>();
+                
+                // go one backward to ensure, that next will return the first occurrence
+                // of the parent to create the group for.
+                commonParentIt.previous();
+                
+                do {
+                    IGUIElement guiElementToGroup = sortedPathsIt.next().getLast();
+                    groupedGUIElements.add(guiElementToGroup);
+                    guiElementsToGroup.remove(guiElementToGroup);
+                    
+                }
+                while (parentToGroup.equals(commonParentIt.next()));
+                
+                groups.put(parentToGroup, groupedGUIElements);
+                
+                // >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> TEST IMPLEMENTATION
+                // System.out.println("group for");
+                // System.out.println(toPathString(parentToGroup));
+                //  
+                // for (IGUIElement element : groupedGUIElements) {
+                //     System.out.println(toPathString(element));
+                // }
+                //  
+                // System.out.println();
+                // <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< TEST IMPLEMENTATION
+            }
+        }
+        while (parentToGroup != null);
+        
+        return groups;
+    }
+
+    /**
+     *
+     */
+    static String toPathString(IGUIElement element) {
+        IGUIElement parent = element;
+        String result = "";
+        
+        while (parent != null) {
+            if (!(parent instanceof GUIElementGroup)) {
+                result = parent.toString() + "/" + result;
+            }
+            else {
+                result = parent.toString().hashCode() + "/" + result;
+            }
+            
+            parent = parent.getParent();
+        }
+        
+        return result.toString();
+    }
+
+    /**
+     *
+     */
+    private static void createSortedPaths(List<IGUIElement>             guiElements,
+                                          List<LinkedList<IGUIElement>> sortedPaths,
+                                          List<IGUIElement>             commonParents,
+                                          int                           maxDistToCommonParent)
+    {
+        for (IGUIElement guiElement : guiElements) {
+            // create the path
+            LinkedList<IGUIElement> path = new LinkedList<>();
+            IGUIElement parent = guiElement;
+            while (parent != null) {
+                if (!(parent instanceof GUIElementGroup)) {
+                    path.addFirst(parent);
+                }
+                
+                parent = parent.getParent();
+            }
+            
+            // sort it into the list of paths
+            int maxEquality = 0;
+            int maxEqualityPos = 0;
+            int pos = 0;
+            
+            for (List<IGUIElement> candidate : sortedPaths) {
+                int equality = 0;
+                while ((equality < candidate.size()) && (equality < path.size()) &&
+                       (candidate.get(equality).equals(path.get(equality))))
+                {
+                    equality++;
+                }
+                
+                if (equality > maxEquality) {
+                    maxEquality = equality;
+                    maxEqualityPos = pos;
+                }
+                
+                pos++;
+            }
+            
+            sortedPaths.add(maxEqualityPos, path);
+            
+            if ((maxEquality > 0) && ((path.size() - maxEquality) < maxDistToCommonParent)) {
+                commonParents.add(maxEqualityPos, path.get(maxEquality - 1));
+            }
+            else {
+                commonParents.add(maxEqualityPos, null);
+            }
+        }
+    }
+
+    /**
+     *
+     */
+    private static IGUIElement getParentToGroup(List<IGUIElement> commonParents) {
+        Map<IGUIElement, Integer> occurrenceCounts = new HashMap<>();
+        Map<IGUIElement, Integer> depths = new HashMap<>();
+        
+        // get the required information about path lengths and occurrence counts
+        for (IGUIElement commonParent : commonParents) {
+            Integer occurrenceCount = occurrenceCounts.get(commonParent);
+            
+            if (occurrenceCount != null) {
+                occurrenceCounts.put(commonParent, occurrenceCount + 1);
+            }
+            else {
+                occurrenceCounts.put(commonParent, 1);
+            }
+            
+            if (!depths.containsKey(commonParent)) {
+                int depth = 0;
+                IGUIElement parent = commonParent;
+                
+                while (parent != null) {
+                    depth++;
+                    parent = parent.getParent();
+                }
+                
+                depths.put(commonParent, depth);
+            }
+        }
+        
+        IGUIElement elementToGroup = null;
+        
+        // get the GUI element being the parent most often 
+        for (IGUIElement commonParent : commonParents) {
+            if (elementToGroup == null) {
+                elementToGroup = commonParent;
+            }
+            else if ((commonParent != null) &&
+                     (!elementToGroup.equals(commonParent)))
+            {
+                int occurrenceCountCandidate = occurrenceCounts.get(commonParent);
+                int depthCandidate = depths.get(commonParent);
+            
+                int occurrenceCountElement = occurrenceCounts.get(elementToGroup);
+                int depthElement = depths.get(elementToGroup);
+                
+                if ((depthCandidate > depthElement) ||
+                    ((depthCandidate == depthElement) &&
+                     (occurrenceCountCandidate > occurrenceCountElement)))
+                {
+                    elementToGroup = commonParent;
+                }
+                else if ((occurrenceCountCandidate == occurrenceCountElement) &&
+                         (depthCandidate == depthElement))
+                {
+                    // in this situation, the order is irrelevant. The GUI elements for which
+                    // both paths were identified as parents are completely different.
+                    // Otherwise, they would have the same parent. But as they are that
+                    // different, they will not occur subsequently in the ordered list
+                    // of GUI elements to group. Hence, we just reuse the one the is currently
+                    // identified as the one to group next.
+                }
+            }
+        }
+        
+        return elementToGroup;
+    }
+
+    /**
+     * 
+     */
+    private RuleUtils() {
+        // prevent instantiation
+    }
+}
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TargetDistanceRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TargetDistanceRule.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TargetDistanceRule.java	(revision 1918)
@@ -136,6 +136,6 @@
             // for HTML: 600 means not on the same page
             // for HTML: 501 means in average not on the same page
-            UsabilityDefectSeverity severity = UsabilityDefectSeverity.getSeverity
-                (ratio, 800, 600, 501, 501, task, taskModel);
+            UsabilitySmellIntensity severity =
+                UsabilitySmellIntensity.getIntensity(ratio, task, taskModel);
 
             if (severity != null) {
@@ -148,6 +148,6 @@
                 parameters.put("distance", ((double) ratio / 1000));
 
-                results.addDefect
-                    (severity, UsabilityDefectDescription.HIGH_TARGET_DISTANCE, parameters);
+                results.addSmell
+                    (task, severity, UsabilitySmellDescription.HIGH_TARGET_DISTANCE, parameters);
             }
         }
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TaskCooccurrenceRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TaskCooccurrenceRule.java	(revision 1493)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/TaskCooccurrenceRule.java	(revision 1918)
@@ -62,4 +62,6 @@
                 int index2 = 1;
                 List<ITask> children = sequence.getChildren();
+                ITaskInfo infoSequence = taskModel.getTaskInfo(sequence);
+                int countSequence = infoSequence.getMeasureValue(TaskMetric.COUNT);
                 
                 while (index2 < children.size()) {
@@ -69,11 +71,9 @@
                     ITaskInfo info2 = taskModel.getTaskInfo(task2);
                     
-                    int ratioTask1 = 1000 * info1.getMeasureValue(TaskMetric.COUNT, sequence) /
-                        info1.getMeasureValue(TaskMetric.COUNT);
-                    int ratioTask2 = 1000 * info2.getMeasureValue(TaskMetric.COUNT, sequence) /
-                            info2.getMeasureValue(TaskMetric.COUNT);
+                    int ratioTask1 = 1000 * countSequence / info1.getMeasureValue(TaskMetric.COUNT);
+                    int ratioTask2 = 1000 * countSequence / info2.getMeasureValue(TaskMetric.COUNT);
                     
-                    createSucceededDefectIfRequired(ratioTask1, task1, task2, results, taskModel);
-                    createPrecededDefectIfRequired(ratioTask2, task1, task2, results, taskModel);
+                    createSucceededSmellIfRequired(ratioTask1, task1, task2, results, taskModel);
+                    createPrecededSmellIfRequired(ratioTask2, task1, task2, results, taskModel);
                     
                     index1 = index2;
@@ -87,13 +87,13 @@
      *
      */
-    private void createSucceededDefectIfRequired(int                       ratio,
-                                                 ITask                     task1,
-                                                 ITask                     task2,
-                                                 UsabilityEvaluationResult results,
-                                                 ITaskModel                taskModel)
+    private void createSucceededSmellIfRequired(int                       ratio,
+                                                ITask                     task1,
+                                                ITask                     task2,
+                                                UsabilityEvaluationResult results,
+                                                ITaskModel                taskModel)
     {
         //TODO document magic numbers
-        UsabilityDefectSeverity severity = UsabilityDefectSeverity.getSeverity
-            (ratio, 900, 700, 500, 300, task1, taskModel);
+        UsabilitySmellIntensity severity =
+            UsabilitySmellIntensity.getIntensity(ratio, task1, taskModel);
 
         if (!isScroll(task1) && !isScroll(task2) && (severity != null)) {
@@ -103,5 +103,6 @@
             parameters.put("ratio", (ratio / 10));
 
-            results.addDefect(severity, UsabilityDefectDescription.COOCCURENCE_SUCCEED, parameters);
+            results.addSmell
+                (task1, severity, UsabilitySmellDescription.COOCCURENCE_SUCCEED, parameters);
         }
     }
@@ -110,13 +111,13 @@
      *
      */
-    private void createPrecededDefectIfRequired(int                       ratio,
-                                                ITask                     task1,
-                                                ITask                     task2,
-                                                UsabilityEvaluationResult results,
-                                                ITaskModel                taskModel)
+    private void createPrecededSmellIfRequired(int                       ratio,
+                                               ITask                     task1,
+                                               ITask                     task2,
+                                               UsabilityEvaluationResult results,
+                                               ITaskModel                taskModel)
     {
         //TODO document magic numbers
-        UsabilityDefectSeverity severity = UsabilityDefectSeverity.getSeverity
-            (ratio, 900, 700, 500, 300, task2, taskModel);
+        UsabilitySmellIntensity severity =
+            UsabilitySmellIntensity.getIntensity(ratio, task2, taskModel);
 
         if (!isScroll(task1) && !isScroll(task2) && (severity != null)) {
@@ -126,5 +127,6 @@
             parameters.put("ratio", (ratio / 10));
 
-            results.addDefect(severity, UsabilityDefectDescription.COOCCURENCE_PRECED, parameters);
+            results.addSmell
+                (task1, severity, UsabilitySmellDescription.COOCCURENCE_PRECED, parameters);
         }
     }
@@ -140,5 +142,6 @@
     private boolean isScroll(ITask task) {
         if (task instanceof IEventTask) {
-            return ((IEventTaskInstance) ((IEventTask) task).getInstances().iterator().next()).getEvent().getType() instanceof Scroll;
+            return ((IEventTaskInstance) ((IEventTask) task).getInstances().iterator().next())
+                .getEvent().getType() instanceof Scroll;
         }
         else if (task instanceof IIteration) {
